///////////////////////////////////////////////////////////////////////////
// Nombre.........: DBFCreate
// Objetivo.......: Generar Codigo a partir de una Tabla.
// Autor Original.: Sudip (HmgForum)
// Autor Modifica.: Ismael farfan
// Fecha..........: Enero 2021
// ...............:
///////////////////////////////////////////////////////////////////////////
#include <minigui.ch>
#include <dbinfo.ch>
// #define NOMSYS    "DBFCreate"     // Nombre Original
#define NOMSYS    "HBGensasaCode Sic Sic!"
#define VERSYS    "Version 1.01.99(R)"
#define SISTEMA   NOMSYS + " " + VERSYS
#define Autor     "GLOBULOS AZULES Y GLOBULOS AMARILLOS"

#define DirActual   GetCurrentFolder() +"\"
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
FUNCTION Main()
      Public nWidth                // Ancho de la Pantalla
      Public nHeight               // Alto  de la Pantalla
      Public aMainCode  as ARRAY   // Alto  de la Pantalla
      Public aMainCdbf  as ARRAY   // Alto  de la Pantalla
      Public inModal               // numero de la pantallas
      Public inButton              // numero de boton
      // HB_SETCODEPAGE("ESWIN")
      SET LANGUAGE TO SPANISH      //SELECT LANGUAGE FOR INTERFACE MESSAGES
      SET DATE FRENCH
      SET century ON
      SET multiple OFF warning
      REQUEST HB_LANG_ES
      SET LANGUAGE TO SPANISH
      SET MULTIPLE OFF WARNING
      REQUEST DBFCDX , DBFFPT
      RDDSETDEFAULT( "DBFCDX" )
      nWidth   := GetDesktopWIDTH()
      nHeight  := GetDesktopHeight() - 50
      inModal  := 512
      inButton := 11
      DEFINE WINDOW vnmain AT 00, 00 WIDTH nWidth HEIGHT nHeight-80 ;
             TITLE SISTEMA ;
             ICON 'MAINICO'  ;
             MAIN
             ///////////////////////////////////////////////////////////////
             @003,003 BUTTON  cmdOpen CAPTION "&DBF Code" ;
                      ACTION DBFCreateAllCode() ;
                      WIDTH 119 HEIGHT 33 FLAT ;
                      TOOLTIP 'Genera codigo para tratamiento como DBF'
             // @003,483 BUTTONEX cm1tipcuen CAPTION "&FireBird Code" ;
             //          ICON "TIPOC" ;
             //          ACTION Nil ;
             //          WIDTH 119 HEIGHT 33 FLAT ;
             //          TOOLTIP 'Genera el codigo para tratamiento FireBird SQL'
             //
             ///////////////////////////////////////////////////////////////
             // @044,284 LABEL lblnamedb VALUE "" ;
             //          WIDTH 470 HEIGHT 30 ;
             //          FONT "Consolas" SIZE 11;
             //          FONTCOLOR BLUE TRANSPARENT
             @nHeight-50,005 BUTTON cmdcopy CAPTION "&Copiar" ;
                      ACTION {|| system.clipboard := vnmain.abcodigo.Value};
                      WIDTH 100 HEIGHT 30 FLAT ;
                      FONT "Consolas" SIZE 11
              DEFINE TAB tabAll OF vnmain AT 040,003 ;
                     WIDTH nWidth-3 HEIGHT nHeight-105 ;
                     FONT "Consolas" SIZE 10 ;
                     VALUE 1 ;
                     BUTTONS FLAT
                  PAGE 'DBF'
                        @038,001 EDITBOX abcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'Mariadb/mysql'
                        @038,001 EDITBOX accodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'SQLite'
                        @038,001 EDITBOX adcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'PostgreSQL'
                        @038,001 EDITBOX aecodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'FireBird'
                        @038,001 EDITBOX afcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'HeidiSQL'
                        @038,001 EDITBOX agcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'Oracle'
                        @038,001 EDITBOX ahcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'DB2'
                        @038,001 EDITBOX aicodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
                  PAGE 'Sybase'
                        @038,001 EDITBOX ajcodigo VALUE "" ;
                                 WIDTH nWidth-14 HEIGHT nHeight-140 ;
                                 FONT "Consolas" SIZE 11
                  END PAGE
              END TAB
      END WINDOW
      MAXIMIZE WINDOW vnmain
      ACTIVATE WINDOW vnmain
RETURN nil
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION DBFCreateAllCode()
      LOCAL mDbfName  := Getfile ( { {'DBF Files','*.DBF'} } , 'Select DBF', DirActual + "Data\")
      LOCAL ccCodigo
      // vnmain.lblnamedb.value := mDbfName
      vnmain.Title := mDbfName
      IF  empty(mDbfName)
          RETURN nil
      ENDIF
      ccCodigo := CreateCode( mDbfName )
      ccCodigo += GenGridCode( mDbfName )
      ccCodigo += GenEditionCode( mDbfName )
      ccCodigo += GenGridCodeV2( mDbfName )
      ccCodigo += DBFGenQuerydata( mDbfName )
      vnmain.abcodigo.value := ccCodigo
      // Mariadb/Mysql  Code
      vnmain.accodigo.value := ""
      ccCodigo := GetMainMariadb()  + hb_OsNewLine()
      ccCodigo += Mariadb_CreaSelect( mDbfName )
      ccCodigo += Mariadb_CreaArray( mDbfName)
      vnmain.accodigo.value := ccCodigo
      // SQlite  Code
      //
      // PostgreSQL  Code
      //
      // Firebird  Code
      //
      // Oracle  Code
      //
      // DB2  Code
      //
      // Sybase  Code
      //
RETURN NIL
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION GetOnlyNameTab(mDbfName)
      LOCAL mcTabla := "", n := rat(".dbf", upper(mDbfName))
      IF n > 0
           mcTabla = substr(mDbfName, 1, n-1)
      ENDIF
RETURN (mcTabla)
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION GetAlias(mDbfName)
      LOCAL mAlias := "", n := rat("\", mDbfName)
      mAlias := substr(mDbfName, n+1)
      n := rat(".", mAlias)
      IF n > 0
          // mAlias := substr(mAlias, 1, n-1)
          mAlias := substr( mAlias, 1, Len(mAlias)-4 )
      ENDIF
RETURN (mAlias)
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION GetCdx(mDbfName)
      LOCAL mCdx := "", n := rat(".dbf", upper(mDbfName))
      IF n > 0
           mCdx = substr(mDbfName, 1, n-1)+".CDX"
      ENDIF
RETURN(mCdx)
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION EndSwith( cInString, cCompareString )
RETURN ( cCompareString == RIGHT( cInString, LEN( cCompareString ) ) )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION Get_NameProgram( cFile )
     LOCAL nPos, cFilePath
     IF ( nPos := RAT("\", cFile) ) != 0
          cFilePath = Alltrim( SUBSTR(cFile, nPos+1, 16) )
          cFilePath = SUBSTR(cFilePath, 1, LEN(cFilePath)-4 )
     ELSE
          cFilePath = ""
     ENDIF
RETURN( cFilePath )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION QuitaPath( cPath_File )
      LOCAL nPos, ccSoloFile
      IF (nPos := RAT("\", cPath_File)) != 0
          ccSoloFile = SUBSTR(cPath_File, nPos+1, 60)
      ELSE
          ccSoloFile = ""
      ENDIF
RETURN( ccSoloFile )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION GetMainMariadb()
     LOCAL ccCodigo := ""
     Initialmaincode()
     ccCodigo := GenCodemain()
     ccCodigo += GenCodeConect()
     ccCodigo += GenCodeSelectdb()
     // vnmain.accodigo.VALUE :=  ccCodigo
RETURN( ccCodigo )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION DobleComilla( ccVariable )
RETURN( Chr(34) + ccVariable + Chr(34) )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
FUNCTION GenNewNameModal()
     inModal += 1
RETURN( "winm" + Alltrim(Str(inModal) ) )
FUNCTION GetNumButton()
     inButton += 1
RETURN( "cmdGoo" + Alltrim(Str(inButton) ) )
#include "Include\DDL_To_Mariadb.bas"
// #include "Include\DDL_To_PostgreSQL.bas"
// #include "Include\DDL_To_SQLite.bas"
// #include "Include\DDL_To_Oracle.bas"
// #include "Include\DDL_To_db2.bas"
// #include "Include\DDL_To_FireBird.bas"
// #include "Include\DDL_To_Sybase.bas"
#include "Include\GEN_CODE_DBF.bas"
#include "Include\TPGen231.prg"
